Index: /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 6346)
+++ /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 6347)
@@ -11,5 +11,6 @@
    !!            3.2  !  2009-04  (G. Madec & NEMO team) 
    !!            3.6  !  2012-05  (C. Rousset) store attenuation coef for use in ice model 
-   !!            3.7  !  2015-11  (G. Madec, A. Coward)  remove optimisation for fix volume 
+   !!             -   !  2015-12  (O. Aumont, J. Jouanno, C. Ethe) use vertical profile of chlorophyll
+   !!            3.7  !  2016-01  (G. Madec, A. Coward)  remove optimisation for fix volume 
    !!----------------------------------------------------------------------
 
@@ -55,15 +56,16 @@
    INTEGER , PUBLIC ::   nksr         !: levels below which the light cannot penetrate (depth larger than 391 m)
  
-   INTEGER, PARAMETER ::   np_RGB  = 1   ! R-G-B     light penetration with constant Chlorophyll
-   INTEGER, PARAMETER ::   np_RGBc = 2   ! R-G-B     light penetration with Chlorophyll data
-   INTEGER, PARAMETER ::   np_2BD  = 3   ! 2 bands   light penetration
-   INTEGER, PARAMETER ::   np_BIO  = 4   ! bio-model light penetration
+   INTEGER, PARAMETER ::   np_RGB    = 1   ! R-G-B     light penetration with constant Chlorophyll
+   INTEGER, PARAMETER ::   np_2BD    = 2   ! 2 bands   light penetration
+   INTEGER, PARAMETER ::   np_BIO    = 3   ! bio-model light penetration
    !
    INTEGER  ::   nqsr    ! user choice of the type of light penetration
    REAL(wp) ::   xsi0r   ! inverse of rn_si0
    REAL(wp) ::   xsi1r   ! inverse of rn_si1
+   
+   REAL(wp) ::   rChl_0 = 0.05_wp   ! value of Chlorophyll used in case of constant Chlorophyll
    !
    REAL(wp) , DIMENSION(3,61)           ::   rkrgb    ! tabulated attenuation coefficients for RGB absorption
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_chl   ! structure of input Chl (file informations, fields read)
+   TYPE(FLD), DIMENSION(:), ALLOCATABLE ::   sf_chl   ! structure of input Chl (file informations, fields read)
 
    !! * Substitutions
@@ -100,4 +102,5 @@
       !! Reference  : Jerlov, N. G., 1968 Optical Oceanography, Elsevier, 194pp.
       !!              Lengaigne et al. 2007, Clim. Dyn., V28, 5, 503-516.
+      !!              Morel, A. and Berthon, J.F., 1989, Limnol Oceanogr 34(8), 1545-1562
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! ocean time-step
@@ -107,8 +110,9 @@
       REAL(wp) ::   zchl, zcoef, z1_2        ! local scalars
       REAL(wp) ::   zc0 , zc1 , zc2 , zc3    !    -         -
-      REAL(wp) ::   zzc0, zzc1, zzc2, zzc3   !    -         -
       REAL(wp) ::   zz0 , zz1                !    -         -
+      REAL(wp) ::   zCb, zCmax, zze, z1_ze, zpsi, zpsimax, zdelpsi, zCtot, zCze
+      REAL(wp) ::   zlogc, zlogc2, zlogc3 
       REAL(wp), POINTER, DIMENSION(:,:)   :: zekb, zekg, zekr
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze0, ze1, ze2, ze3, zea, ztrdt
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze0, ze1, ze2, ze3, zea, zchl3d, ztrdt
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zetot
       !!----------------------------------------------------------------------
@@ -149,5 +153,5 @@
       !                         !--------------------------------!
       !
-      CASE( np_BIO )                   !==  bio-model fluxes  ==!
+      CASE( np_BIO )                !==  bio-model fluxes  ==!
          !
          DO jk = 1, nksr
@@ -155,32 +159,54 @@
          END DO
          !
-      CASE( np_RGB , np_RGBc )         !==  R-G-B fluxes  ==!
-         !
-         CALL wrk_alloc( jpi,jpj,       zekb, zekg, zekr        ) 
-         CALL wrk_alloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea ) 
-         !
-         IF( nqsr == np_RGBc ) THEN          !*  Variable Chlorophyll
+      CASE( np_RGB )                !==  R-G-B fluxes  ==!
+         !
+         CALL wrk_alloc( jpi,jpj,       zekb, zekg, zekr                ) 
+         CALL wrk_alloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea, zchl3d ) 
+         !
+         SELECT CASE( nn_chldta )         ! set 3D chlorophyll field
+         !
+         CASE( 0 )                           ! constant 
+            DO jk = 1, nksr + 1
+               zchl3d(:,:,jk) = rChl_0
+            END DO
+            !
+         CASE( 1 )                           ! surface chlorophyl data spread uniformly on the vertical
             CALL fld_read( kt, 1, sf_chl )         ! Read Chl data and provides it at the current time step
-            DO jj = 2, jpjm1                       ! Separation in R-G-B depending of the surface Chl
+            DO jk = 1, nksr + 1                    ! uniform vertical profile
+               zchl3d(:,:,jk) = sf_chl(1)%fnow(:,:,1) 
+            END DO
+            !
+         CASE( 2 )                           ! surface chlorophyl data + Morel and Berthon (1989) profile
+            CALL fld_read( kt, 1, sf_chl )         ! Read Chl data and provides it at the current time step
+            DO jj = 2, jpjm1                       ! Chl profile = F( surface Chl value)
                DO ji = fs_2, fs_jpim1
-                  zchl = MIN( 10. , MAX( 0.03, sf_chl(1)%fnow(ji,jj,1) ) )
-                  irgb = NINT( 41 + 20.*LOG10(zchl) + 1.e-15 )
-                  zekb(ji,jj) = rkrgb(1,irgb)
-                  zekg(ji,jj) = rkrgb(2,irgb)
-                  zekr(ji,jj) = rkrgb(3,irgb)
+                  zchl    = sf_chl(1)%fnow(ji,jj,1)
+                  zCtot   =  40.6_wp *  zchl**0.459
+                  zze     = 568.2_wp * zCtot**(-0.746)
+                  IF( zze > 102. )   zze = 200.0 * zCtot**(-0.293)
+                  zlogc   = LOG( zchl )
+!!gm : instead of this :
+                  zlogc2  = zlogc * zlogc
+                  zlogc3  = zlogc * zlogc * zlogc
+                  zCb     = 0.768 + 0.087 * zlogc - 0.179 * zlogc2 - 0.025 * zlogc3
+                  zCmax   = 0.299 - 0.289 * zlogc + 0.579 * zlogc2
+                  zpsimax = 0.6   - 0.640 * zlogc + 0.021 * zlogc2 + 0.115 * zlogc3
+                  zdelpsi = 0.710 + 0.159 * zlogc + 0.021 * zlogc2
+!!gm faster & more precise:
+!                  zCb     = 0.768 + zlogc * (  (  0.087 + zlogc * (- 0.179 - zlogc * 0.025 )  )
+!                  zCmax   = 0.299 + zlogc * (   - 0.289 + zlogc *    0.579  )
+!                  zpsimax = 0.6   + zlogc * (  (- 0.640 + zlogc * (  0.021 + zlogc * 0.115 )  )
+!                  zdelpsi = 0.710 + zlogc * (     0.159 + zlogc *    0.021  )
+!!gm end          
+                  zCze    = 1.12_wp * (zchl)**0.803 
+                  z1_ze   = 1._wp / zze
+                  DO jk = 1, nksr + 1
+                     zpsi = gdept_n(ji,jj,jk) * z1_ze
+                     zchl3d(ji,jj,jk) = zCze * ( zCb + zCmax * EXP( -( (zpsi - zpsimax) / zdelpsi )**2 ) )
+                  END DO
                END DO
             END DO
-         ELSE                                !* constant chrlorophyll
-            zchl = 0.05                            ! constant chlorophyll
-            !                                      ! Separation in R-G-B depending of the chlorophyll
-            irgb = NINT( 41 + 20.*LOG10( zchl ) + 1.e-15 )
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1
-                  zekb(ji,jj) = rkrgb(1,irgb)                      
-                  zekg(ji,jj) = rkrgb(2,irgb)
-                  zekr(ji,jj) = rkrgb(3,irgb)
-               END DO
-            END DO
-         ENDIF
+            !
+         END SELECT
          !
          zcoef  = ( 1. - rn_abs ) / 3._wp    !* surface equi-partition in R-G-B
@@ -195,5 +221,14 @@
          END DO
          !
-         DO jk = 2, nksr+1                   !* interior equi-partition in R-G-B
+         DO jk = 2, nksr+1                   !* interior partition in R-G-B function of 3D Chl
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  zchl = MIN( 10._wp , MAX( 0.03_wp , zchl3d(ji,jj,jk) ) )
+                  irgb = NINT( 41._wp + 20._wp * LOG10(zchl) + 1.e-15 )
+                  zekb(ji,jj) = rkrgb(1,irgb)
+                  zekg(ji,jj) = rkrgb(2,irgb)
+                  zekr(ji,jj) = rkrgb(3,irgb)
+               END DO
+            END DO
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -219,6 +254,6 @@
          END DO
          !
-         CALL wrk_dealloc( jpi,jpj,        zekb, zekg, zekr        ) 
-         CALL wrk_dealloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea ) 
+         CALL wrk_dealloc( jpi,jpj,       zekb, zekg, zekr                ) 
+         CALL wrk_dealloc( jpi,jpj,jpk,   ze0, ze1, ze2, ze3, zea, zchl3d ) 
          !
       CASE( np_2BD  )            !==  2-bands fluxes  ==!
@@ -309,6 +344,6 @@
       INTEGER  ::   ji, jj, jk                  ! dummy loop indices
       INTEGER  ::   ios, irgb, ierror, ioptio   ! local integer
-      REAL(wp) ::   zz0, zc0 , zc1, zcoef      ! local scalars
-      REAL(wp) ::   zz1, zc2 , zc3, zchl       !   -      -
+!      REAL(wp) ::   zz0, zc0 , zc1, zcoef      ! local scalars
+!      REAL(wp) ::   zz1, zc2 , zc3, zchl       !   -      -
       !
       CHARACTER(len=100) ::   cn_dir   ! Root directory for location of ssr files
@@ -321,14 +356,14 @@
       IF( nn_timing == 1 )   CALL timing_start('tra_qsr_init')
       !
-      REWIND( numnam_ref )              ! Namelist namtra_qsr in reference     namelist
+      REWIND( numnam_ref )       ! Namelist namtra_qsr in reference     namelist
       READ  ( numnam_ref, namtra_qsr, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namtra_qsr in reference namelist', lwp )
       !
-      REWIND( numnam_cfg )              ! Namelist namtra_qsr in configuration namelist
+      REWIND( numnam_cfg )       ! Namelist namtra_qsr in configuration namelist
       READ  ( numnam_cfg, namtra_qsr, IOSTAT = ios, ERR = 902 )
 902   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namtra_qsr in configuration namelist', lwp )
       IF(lwm) WRITE ( numond, namtra_qsr )
       !
-      IF(lwp) THEN                ! control print
+      IF(lwp) THEN               ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'tra_qsr_init : penetration of the surface solar radiation'
@@ -339,5 +374,5 @@
          WRITE(numout,*) '      bio-model            light penetration       ln_qsr_bio = ', ln_qsr_bio
          WRITE(numout,*) '      light penetration for ice-model (LIM3)       ln_qsr_ice = ', ln_qsr_ice
-         WRITE(numout,*) '      RGB : Chl data (=1) or cst value (=0)        nn_chldta  = ', nn_chldta
+         WRITE(numout,*) '      RGB : Chl data (=1,2) or cst value (=0)      nn_chldta  = ', nn_chldta
          WRITE(numout,*) '      RGB & 2 bands: fraction of light (rn_si1)    rn_abs     = ', rn_abs
          WRITE(numout,*) '      RGB & 2 bands: shortess depth of extinction  rn_si0     = ', rn_si0
@@ -346,5 +381,5 @@
       ENDIF
       !
-      ioptio = 0                    ! Parameter control
+      ioptio = 0                 ! Parameter control
       IF( ln_qsr_rgb  )   ioptio = ioptio + 1
       IF( ln_qsr_2bd  )   ioptio = ioptio + 1
@@ -355,9 +390,8 @@
       !
       IF( ln_qsr_rgb .AND. nn_chldta == 0 )   nqsr = np_RGB 
-      IF( ln_qsr_rgb .AND. nn_chldta == 1 )   nqsr = np_RGBc
       IF( ln_qsr_2bd                      )   nqsr = np_2BD
       IF( ln_qsr_bio                      )   nqsr = np_BIO
       !
-      !                             ! Initialisation
+      !                          ! Initialisation
       xsi0r = 1._wp / rn_si0
       xsi1r = 1._wp / rn_si1
@@ -365,5 +399,5 @@
       SELECT CASE( nqsr )
       !                               
-      CASE( np_RGB , np_RGBc )         !==  Red-Green-Blue light penetration  ==!
+      CASE( np_RGB )             !==  Red-Green-Blue light penetration  ==!
          !                             
          IF(lwp)   WRITE(numout,*) '   R-G-B   light penetration '
@@ -375,6 +409,11 @@
          IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_1d(nksr+1), ' m'
          !
-         IF( nqsr == np_RGBc ) THEN                ! Chl data : set sf_chl structure
-            IF(lwp) WRITE(numout,*) '        Chlorophyll read in a file'
+         SELECT CASE( nn_chldta )         ! set 3D chlorophyll field
+         CASE( 0 )                           ! constant
+            IF(lwp) WRITE(numout,*) '        constant Chlorophyll set to rChl_0 =', rChl_0 
+            !
+         CASE( 1 , 2 )                       ! 3D chlorophyl field : read 2D surface data
+            !
+            IF(lwp) WRITE(numout,*) '        surface 2D Chlorophyll field read in a file'
             ALLOCATE( sf_chl(1), STAT=ierror )
             IF( ierror > 0 ) THEN
@@ -386,10 +425,11 @@
             CALL fld_fill( sf_chl, (/ sn_chl /), cn_dir, 'tra_qsr_init',   &
                &           'Solar penetration function of read chlorophyll', 'namtra_qsr' )
-         ENDIF
-         IF( nqsr == np_RGB ) THEN                 ! constant Chl
-            IF(lwp) WRITE(numout,*) '        Constant Chlorophyll concentration = 0.05'
-         ENDIF
-         !
-      CASE( np_2BD )                   !==  2 bands light penetration  ==!
+            !
+            IF( lwp .AND. nn_chldta == 1 )   WRITE(numout,*) '        profile of chlorophyll : Chl(z) = Chl(z=0)'
+            IF( lwp .AND. nn_chldta == 2 )   WRITE(numout,*) '        profile of chlorophyll : Chl(z) = Func[Chl(z=0)]'
+            !
+         END SELECT
+         !
+      CASE( np_2BD )             !==  2 bands light penetration  ==!
          !
          IF(lwp)  WRITE(numout,*) '   2 bands light penetration'
@@ -398,5 +438,5 @@
          IF(lwp) WRITE(numout,*) '        level of light extinction = ', nksr, ' ref depth = ', gdepw_1d(nksr+1), ' m'
          !
-      CASE( np_BIO )                   !==  BIO light penetration  ==!
+      CASE( np_BIO )                         !==  BIO light penetration  ==!
          !
          IF(lwp) WRITE(numout,*) '   bio-model light penetration'
Index: /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90
===================================================================
--- /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 6346)
+++ /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 6347)
@@ -174,5 +174,10 @@
                   &                             +  0.15 * zrau(ji,jj)          * zmskd2(ji,jj)  )
                ! add to the eddy viscosity coef. previously computed
+# if defined key_zdftmx_new
+               ! key_zdftmx_new: New internal wave-driven param: use avs value computed by zdftmx
+               avs (ji,jj,jk) = avs(ji,jj,jk) + zavfs + zavds
+# else
                avs (ji,jj,jk) = avt(ji,jj,jk) + zavfs + zavds
+# endif
                avt (ji,jj,jk) = avt(ji,jj,jk) + zavft + zavdt
                avm (ji,jj,jk) = avm(ji,jj,jk) + MAX( zavft + zavdt, zavfs + zavds )
Index: /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6346)
+++ /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6347)
@@ -78,5 +78,5 @@
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      INTEGER  ::   iikn, iiki, ikt, imkt   ! local integer
+      INTEGER  ::   iikn, iiki, ikt   ! local integer
       REAL(wp) ::   zN2_c        ! local scalar
       INTEGER, POINTER, DIMENSION(:,:) ::   imld   ! 2D workspace
@@ -123,5 +123,4 @@
             iiki = imld(ji,jj)
             iikn = nmln(ji,jj)
-            imkt = mikt(ji,jj)
             hmld (ji,jj) = gdepw_n(ji,jj,iiki  ) * ssmask(ji,jj)    ! Turbocline depth 
             hmlp (ji,jj) = gdepw_n(ji,jj,iikn  ) * ssmask(ji,jj)    ! Mixed layer depth
Index: /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 6346)
+++ /branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 6347)
@@ -323,5 +323,6 @@
                   zwlc = zind * rn_lc * zus * SIN( rpi * gdepw_n(ji,jj,jk) / zhlc(ji,jj) )
                   !                                           ! TKE Langmuir circulation source term
-                  en(ji,jj,jk) = en(ji,jj,jk) + rdt * (1._wp - fr_i(ji,jj) ) * ( zwlc * zwlc * zwlc ) / zhlc(ji,jj) * wmask(ji,jj,jk) * tmask(ji,jj,1)
+                  en(ji,jj,jk) = en(ji,jj,jk) + rdt * (1._wp - fr_i(ji,jj) ) * ( zwlc * zwlc * zwlc )   &
+                     &                              / zhlc(ji,jj) * wmask(ji,jj,jk) * tmask(ji,jj,1)
                END DO
             END DO
@@ -732,5 +733,16 @@
       !
       ri_cri   = 2._wp    / ( 2._wp + rn_ediss / rn_ediff )   ! resulting critical Richardson number
+# if defined key_zdftmx_new
+      ! key_zdftmx_new: New internal wave-driven param: specified value of rn_emin & rmxl_min are used
+      rn_emin  = 1.e-10_wp
+      rmxl_min = 1.e-03_wp
+      IF(lwp) THEN                  ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'zdf_tke_init :  New tidal mixing case: force rn_emin = 1.e-10 and rmxl_min = 1.e-3 '
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+# else
       rmxl_min = 1.e-6_wp / ( rn_ediff * SQRT( rn_emin ) )    ! resulting minimum length to recover molecular viscosity
+# endif
       !
       IF(lwp) THEN                    !* Control print
